﻿Imports PdfSharp.Pdf.IO
Imports System.IO
Imports PdfSharp.Pdf
Imports PdfSharp.Drawing

Public Class Form1



    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click


        Dim currentPath As String
        currentPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly.Location)

        Dim pdfDoc As PdfSharp.Pdf.PdfDocument

        'read the original pdf
        pdfDoc = PdfReader.Open(currentPath & "\Page Landscape.pdf")
        'save the pdf, this will mess up the media-box
        pdfDoc.Save(currentPath & "\Page Landscape - 1st save, WRONG.pdf")

        'read the messed up pdf
        pdfDoc = PdfReader.Open(currentPath & "\Page Landscape - 1st save, WRONG.pdf")
        'save it again, this seem to fix the mediabox
        pdfDoc.Save(currentPath & "\Page Landscape - 2nd save, OK again.pdf")





        'here is a home-made fix, it seem to works, but I'm not sure if it's the correct thing to do
        pdfDoc = PdfReader.Open(currentPath & "\Page Landscape.pdf")
        FixLandscapePages(pdfDoc)
        pdfDoc.Save(currentPath & "\Page Landscape - 1st save with fix, OK.pdf")




        System.Diagnostics.Process.Start(currentPath & "\Page Landscape.pdf")
        System.Diagnostics.Process.Start(currentPath & "\Page Landscape - 1st save, WRONG.pdf")
        System.Diagnostics.Process.Start(currentPath & "\Page Landscape - 2nd save, OK again.pdf")

        System.Diagnostics.Process.Start(currentPath & "\Page Landscape - 1st save with fix, OK.pdf")

    End Sub




    Public Shared Sub FixLandscapePages(pdfDoc As PdfSharp.Pdf.PdfDocument)

        'landscape pages fix
        'the fix must be the last action executed against the page, and it must be done exactly one time for each page


        For Each page As PdfPage In pdfDoc.Pages
            If page.MediaBox.Width <> page.Width.Point Or page.MediaBox.Height <> page.Height.Point Then
                page.MediaBox = New PdfRectangle(New XPoint(0, 0), New XPoint(page.Width.Point, page.Height.Point))
            End If

        Next

    End Sub



End Class
